﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;


namespace DPs01
{
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }

        //
        //Creating a Dependency Property Example
        //
        public String TestDP
        {
            get { return (String)GetValue(TestDPProperty); }
            set { SetValue(TestDPProperty, value); }
        }

        // Using a DependencyProperty as the backing store for TestDP.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty TestDPProperty =
            DependencyProperty.Register("TestDP", typeof(String), typeof(MainPage), new PropertyMetadata(""));





        //
        //Creating an Attached Property Example
        //
        public static int GetMyAP(DependencyObject obj)
        {
            return (int)obj.GetValue(MyAPProperty);
        }

        public static void SetMyAP(DependencyObject obj, int value)
        {
            obj.SetValue(MyAPProperty, value);
        }

        public static readonly DependencyProperty MyAPProperty =
            DependencyProperty.RegisterAttached("MyAP", typeof(int), typeof(MainPage),
                new PropertyMetadata(0));




        //
        //Dependency Property Callback Example
        //
        public static void OnTextChanged(DependencyObject d,
            DependencyPropertyChangedEventArgs e)
        {
            TextBox tb = d as TextBox;
            if (tb != null)
            {
                if (e.OldValue != e.NewValue)
                {
                    tb.FontStyle = Windows.UI.Text.FontStyle.Italic;
                }
            }
        }

        public static TextBox CreateTB()
        {
            TextBox tb = new TextBox();
            tb.Text = "Type something here";
            return tb;
        }
        
    }
}
