﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace Brushes
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }

        private void SetColor_Click(object sender, RoutedEventArgs e)
        {
            Color bkgdColor = Color.FromArgb(
                (byte)AlphaSlider.Value,
                (byte)RedSlider.Value,
                (byte)GreenSlider.Value,
                (byte)BlueSlider.Value);

            SolidColorBrush bkgdBrush = new SolidColorBrush(bkgdColor);
            ColorDisplay.Background = bkgdBrush;
        }

        private void SetGradient_Click(object sender, RoutedEventArgs e)
        {
            LGBrush.StartPoint = new Point(StartXSlider.Value, StartYSlider.Value);
            LGBrush.EndPoint = new Point(EndXSlider.Value, EndYSlider.Value);

            if (PadMethod.IsChecked == true)
                LGBrush.SpreadMethod = GradientSpreadMethod.Pad;
            else if (ReflectMethod.IsChecked == true)
                LGBrush.SpreadMethod = GradientSpreadMethod.Reflect;
            else
                LGBrush.SpreadMethod = GradientSpreadMethod.Repeat;

            if (SRgb.IsChecked == true)
                LGBrush.ColorInterpolationMode = ColorInterpolationMode.SRgbLinearInterpolation;
            else
                LGBrush.ColorInterpolationMode = ColorInterpolationMode.ScRgbLinearInterpolation;
        }
    }
}
