﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace ColorBrowser
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
            ColorCollection ColorList = new ColorCollection();
            var groupedColors = from c in ColorList
                                orderby c.ColorName
                                group c by c.Key into g
                                select g;
            ColorCVS.Source = groupedColors;
            ColorCVS.View.CurrentChanged += View_CurrentChanged;

        }

        void View_CurrentChanged(object sender, object e)
        {
 	        ListOfColors.ScrollIntoView(ColorCVS.View.CurrentItem);
        }

        private void MoveFirst_Click(object sender, RoutedEventArgs e)
        {
            ColorCVS.View.MoveCurrentToFirst();
        }

        private void MovePrevious_Click(object sender, RoutedEventArgs e)
        {
            ColorCVS.View.MoveCurrentToPrevious();
            if (ColorCVS.View.IsCurrentBeforeFirst)
                ColorCVS.View.MoveCurrentToFirst();
        }

        private void MoveNext_Click(object sender, RoutedEventArgs e)
        {
            ColorCVS.View.MoveCurrentToNext();
            if (ColorCVS.View.IsCurrentAfterLast)
                ColorCVS.View.MoveCurrentToLast();
        }

        private void MoveLast_Click(object sender, RoutedEventArgs e)
        {
            ColorCVS.View.MoveCurrentToLast();
        }   

    }
}
