﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.UI;
using System.Collections.ObjectModel;
using System.Reflection;

namespace BasicPageItems
{
    public class ColorCollection : ObservableCollection<ColorDetails>
    {
        public ColorCollection()
        {
            LoadStandardColors();
        }

        public void LoadStandardColors()
        {
            Type t = typeof(Colors);
            IEnumerable<PropertyInfo> pList = t.GetTypeInfo().DeclaredProperties;

            foreach (PropertyInfo p in pList)
            {
                ColorDetails cd = new ColorDetails();
                Color c = (Color)p.GetValue(null);
                cd.ColorName = p.Name;
                cd.ActualColor = c;
                cd.Red = Color.FromArgb(255, c.R, 0, 0).ToString();
                cd.Green = Color.FromArgb(255, 0, c.G, 0).ToString();
                cd.Blue = Color.FromArgb(255, 0, 0, c.B).ToString();
                cd.HexValue = c.ToString();
                cd.Key = p.Name.Substring(0, 1);

                Add(cd);
            }
        }
    }
}
