﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.ApplicationModel.Activation;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace Lifecycle
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class ExtendedSplash : Page
    {
        private SplashScreen splash;
        private Rect imageRect;

        public ExtendedSplash()
        {
            this.InitializeComponent();
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);
            Window.Current.SizeChanged += Current_SizeChanged;
            splash = (SplashScreen)(e.Parameter);
            imageRect = splash.ImageLocation;
            this.Loaded += (object s, RoutedEventArgs a) => { PositionImage(); };
        }

        void Current_SizeChanged(object sender, Windows.UI.Core.WindowSizeChangedEventArgs e)
        {
            imageRect = splash.ImageLocation;
            PositionImage();
        }

        void PositionImage()
        {
            this.SplashImage.SetValue(Canvas.LeftProperty, imageRect.Left);
            this.SplashImage.SetValue(Canvas.TopProperty, imageRect.Top);
            this.SplashImage.Height = imageRect.Height;
            this.SplashImage.Width = imageRect.Width;
            this.Ring.SetValue(Canvas.LeftProperty, imageRect.Left);
            this.Ring.SetValue(Canvas.TopProperty, imageRect.Top + SplashImage.Height + 20);
            this.Ring.Width = imageRect.Width;
            this.CloseButton.SetValue(Canvas.LeftProperty,
            imageRect.Left + (imageRect.Width / 2) - CloseButton.ActualWidth / 2);
            this.CloseButton.SetValue(Canvas.TopProperty, imageRect.Top + SplashImage.Height + 50);
        }

        private void CloseButton_Click(object sender, RoutedEventArgs e)
        {
            Frame rootFrame = (Frame)Window.Current.Content;
            rootFrame.Navigate(typeof(MainPage));
            Window.Current.Content = rootFrame;
        }

        
    }
}
