﻿' The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238
Imports Windows.ApplicationModel.Activation
Imports Windows.UI.Core
Imports Lifecycle.Common

''' <summary>
''' An empty page that can be used on its own or navigated to within a Frame.
''' </summary>
Public NotInheritable Class ExtendedSplash
    Inherits Page

    Private splash As SplashScreen
    Private imageRect As Rect

    Protected Overrides Sub OnNavigatedTo(e As NavigationEventArgs)
        MyBase.OnNavigatedTo(e)
        AddHandler Window.Current.SizeChanged, AddressOf Current_SizeChanged
        splash = DirectCast(e.Parameter, SplashScreen)
        imageRect = splash.ImageLocation
        AddHandler Me.Loaded, Sub(s As Object, a As RoutedEventArgs)
                                  PositionImage()
                              End Sub
    End Sub

    Private Sub Current_SizeChanged(sender As Object, e As WindowSizeChangedEventArgs)
        imageRect = splash.ImageLocation
        PositionImage()
    End Sub

    Private Sub PositionImage()
        Me.SplashImage.SetValue(Canvas.LeftProperty, imageRect.Left)
        Me.SplashImage.SetValue(Canvas.TopProperty, imageRect.Top)
        Me.SplashImage.Height = imageRect.Height
        Me.SplashImage.Width = imageRect.Width

        Me.Ring.SetValue(Canvas.LeftProperty, imageRect.Left)
        Me.Ring.SetValue(Canvas.TopProperty, imageRect.Top + SplashImage.Height + 20)
        Me.Ring.Width = imageRect.Width

        Me.CloseButton.SetValue(Canvas.LeftProperty, imageRect.Left + (imageRect.Width / 2) - CloseButton.ActualWidth / 2)
        Me.CloseButton.SetValue(Canvas.TopProperty, imageRect.Top + SplashImage.Height + 50)
    End Sub

    Private Sub CloseButton_Click(sender As Object, e As RoutedEventArgs) _
        Handles CloseButton.Click

        Dim rootFrame As Frame = DirectCast(Window.Current.Content, Frame)
        rootFrame.Navigate(GetType(MainPage))
        Window.Current.Content = rootFrame
    End Sub
End Class
