﻿Imports Windows.Storage.Streams

''' <summary>
''' A basic page that provides characteristics common to most applications.
''' </summary>
Public NotInheritable Class MainPage
    Inherits Page

    Public ReadOnly Property NavigationHelper As Common.NavigationHelper
        Get
            Return Me._navigationHelper
        End Get
    End Property
    Private _navigationHelper As Common.NavigationHelper

    Public ReadOnly Property DefaultViewModel As Common.ObservableDictionary
        Get
            Return Me._defaultViewModel
        End Get
    End Property
    Private _defaultViewModel As New Common.ObservableDictionary()
    Private AllColors As ColorCollection

    Public Sub New()

        InitializeComponent()
        Me._navigationHelper = New Common.NavigationHelper(Me)
        AddHandler Me._navigationHelper.LoadState, AddressOf NavigationHelper_LoadState
        AddHandler Me._navigationHelper.SaveState, AddressOf NavigationHelper_SaveState

        AllColors = New ColorCollection()

    End Sub

   
    Private Sub NavigationHelper_LoadState(sender As Object, e As Common.LoadStateEventArgs)

    End Sub

    
    Private Sub NavigationHelper_SaveState(sender As Object, e As Common.SaveStateEventArgs)

    End Sub

#Region "NavigationHelper registration"

    ''' The methods provided in this section are simply used to allow
    ''' NavigationHelper to respond to the page's navigation methods.
    ''' 
    ''' Page specific logic should be placed in event handlers for the  
    ''' <see cref="Common.NavigationHelper.LoadState"/>
    ''' and <see cref="Common.NavigationHelper.SaveState"/>.
    ''' The navigation parameter is available in the LoadState method 
    ''' in addition to page state preserved during an earlier session.

    Protected Overrides Sub OnNavigatedTo(e As NavigationEventArgs)
        _navigationHelper.OnNavigatedTo(e)
    End Sub

    Protected Overrides Sub OnNavigatedFrom(e As NavigationEventArgs)
        _navigationHelper.OnNavigatedFrom(e)
    End Sub

#End Region


    Private Sub ColorSearch_QuerySubmitted(sender As SearchBox, args As SearchBoxQuerySubmittedEventArgs) Handles ColorSearch.QuerySubmitted
        Me.Frame.Navigate(GetType(ColorSearchResults), args.QueryText)
    End Sub

    Private Sub ColorSearch_SuggestionsRequested(sender As SearchBox, args As SearchBoxSuggestionsRequestedEventArgs) Handles ColorSearch.SuggestionsRequested
        Dim suggestions = args.Request.SearchSuggestionCollection

        For Each c As ColorDetails In AllColors

            If (c.ColorName.Equals(args.QueryText, StringComparison.CurrentCultureIgnoreCase)) Then

                Dim imageUri As Uri = New Uri("ms-appx:///Assets/Logo.scale-100.png")
                Dim imageSource = RandomAccessStreamReference.CreateFromUri(imageUri)
                suggestions.AppendResultSuggestion(c.ColorName, c.HexValue, c.ColorName, imageSource, "")
                suggestions.AppendSearchSeparator("")

                Exit For

            End If

        Next



        For Each c As ColorDetails In AllColors
            If c.ColorName.StartsWith(args.QueryText, StringComparison.CurrentCultureIgnoreCase) Then suggestions.AppendQuerySuggestion(c.ColorName)
            If suggestions.Size = 25 Then
                Exit For
            End If
        Next
    End Sub

    Private Sub ColorSearch_ResultSuggestionChosen(sender As SearchBox, args As SearchBoxResultSuggestionChosenEventArgs) Handles ColorSearch.ResultSuggestionChosen
        Me.Frame.Navigate(GetType(ColorItem), args.Tag)
    End Sub

    

End Class

